#if defined(__linux__)
#if defined(__arm__)

/*
 * Use Linux system call.
 */

#define SYS_exit   1
#define SYS_read   3
#define SYS_write  4
#define SYS_open   5
#define SYS_close  6
#define SYS_ioctl 54

	.section .text

	.globl	_exit
	.type	_exit, %function
_exit:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_exit
	b	_syscall

	.globl	read
	.type	read, %function
read:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_read
	b	_syscall

	.globl	write
	.type	write, %function
write:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_write
	b	_syscall

	.globl	open
	.type	open, %function
open:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_open
	b	_syscall

	.globl	close
	.type	close, %function
close:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_close
	b	_syscall

	.globl	ioctl
	.type	ioctl, %function
ioctl:
	push	{ r4, r5, r6, r7 }
	mov	r7, #SYS_ioctl
	b	_syscall

_syscall:
	swi	0
	pop	{ r4, r5, r6, r7 }
	cmp	r0, #0
	bge	ret
err:	rsb	r0, r0, #0
	ldr	r1, _errno_addr
	str	r0, [r1]
	mvn	r0, #0
ret:	mov	pc, lr

	.align	4
_errno_addr:
	.long	errno
#endif
#endif
